
#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <bautils.h>
#include <eikenv.h>
#include <stdlib.h>
#include <string.h>
extern "C"
	{
	extern char *sysarg_args_data;
	}

#if defined (EPOC_AS_APP) && !defined (UIQ3) && !defined(S60V3)
#include "ECompXL.h"
#endif

#if defined (UIQ2) || defined (S60V2)
#define xrick_app_dir "c:\\system\\apps\\xrick\\data.zip"
#else
#define xrick_app_dir "c:\\resource\\apps\\xrick\\data.zip"
#endif

class CXRickApp : public CSDLApp {
public:
	CXRickApp();
	~CXRickApp();

	TUid AppDllUid() const;
#if defined (EPOC_AS_APP)  && !defined (UIQ3) && !defined(S60V3)
	TECompXL    iECompXL;
#endif

#if defined (UIQ3) 
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
#endif
/*
**
* This has a default empty implemen
* Is called just before SDL_Main is
*/
virtual void PreInitializeAppL()
{
	if(sysarg_args_data == NULL) {
		sysarg_args_data = strdup(xrick_app_dir);
		sysarg_args_data[0] = BitmapStoreName()[0];
	}
}

};

#ifdef EPOC_AS_APP

// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
#if !defined (UIQ3) && !defined(S60V3)
EXPORT_C 
#endif
CApaApplication* NewApplication() {
	// Return pointer to newly created xrick
	return new CXRickApp;
}

#if defined (UIQ3) || defined (__SERIES60_30__)
#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}
#endif

#endif // EPOC_AS_APP

#if !defined (UIQ3) && !defined (__SERIES60_30__)
GLDEF_C  TInt E32Dll(TDllReason) {
	return KErrNone;
}
#endif
CXRickApp::CXRickApp() {
}

CXRickApp::~CXRickApp() {
}

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CXRickApp::AppDllUid() const {
		
#if defined (UIQ3) || defined(S60V3)
	return TUid::Uid(0xF01F9B44);
#else
	return TUid::Uid(0x101F9B44);
#endif
}
#if defined (UIQ3)
#include <XRick.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CXRickApp::ViewResourceId() {
	
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////


